--------------------------------------------
-- Module Name: two_out_of_5_dataflow
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VComponents.all;

Entity two_out_of_5_dataflow Is
port(
		x  : in STD_LOGIC_VECTOR (3 downto 0);
		y  : out STD_LOGIC_VECTOR (4 downto 0)
	);
end two_out_of_5_dataflow;

Architecture behavior of two_out_of_5_dataflow Is

signal y_int : STD_LOGIC_VECTOR (4 downto 0) := "00000";

begin
	y <= y_int;
	
	y_int(0) <= (not(x(3)) and not(x(2)) and not(x(1))) or (not(x(2)) and x(1) and x(0)) or (x(2) and x(1) and not(x(0)));
	y_int(1) <= (not(x(3)) and not(x(1)) and not(x(0))) or (x(2) and x(1) and x(0)) or (not(x(2)) and x(1) and not(x(0)));
	y_int(2) <= (not(x(3)) and not(x(1)) and x(0)) or (x(3) and not(x(0))) or (not(x(2)) and x(1) and not(x(0)));
	y_int(3) <= (x(2) and not(x(1))) or (x(3) and x(0)) or (not(x(2)) and x(1) and x(0));
	y_int(4) <= x(3) or (x(2) and x(1));
	
end behavior;