--------------------------------------------
-- Module Name: lab2_3_2_dataflow
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

Entity lab2_3_2_dataflow Is
port(
		a  	 		: in STD_LOGIC_VECTOR (3 downto 0);
		b  	 		: in STD_LOGIC_VECTOR (3 downto 0);
		cin  		: in STD_LOGIC;
		seg0 		: out STD_LOGIC_VECTOR (6 downto 0);
		an	 		: out STD_LOGIC_VECTOR (7 downto 0);
		m_s_digit 	: out STD_LOGIC
	);
end lab2_3_2_dataflow;

Architecture behavior of lab2_3_2_dataflow Is
	Component rca_dataflow
	port (
		a  	 : in STD_LOGIC_VECTOR (3 downto 0);
		b  	 : in STD_LOGIC_VECTOR (3 downto 0);
		cin  : in STD_LOGIC;
		s 	 : out STD_LOGIC_VECTOR (3 downto 0);
		cout : out STD_LOGIC
	);	
	End Component;

	Component mux_2_to_1_behavior
	port (
		x  : in STD_LOGIC;
		y  : in STD_LOGIC;
		s  : in STD_LOGIC;		
		m  : out STD_LOGIC
	);	
	End Component;

	Component bcdto7segment_dataflow
	port (
		x 	: in STD_LOGIC_VECTOR(3 downto 0);
		an 	: out STD_LOGIC_VECTOR(7 downto 0);
		seg : out STD_LOGIC_VECTOR(6 downto 0)
	);	
	End Component;	

signal bcd_out  : STD_LOGIC_VECTOR (3 downto 0);	
signal rca_s 	: STD_LOGIC_VECTOR (3 downto 0);
signal rca_s6 	: STD_LOGIC_VECTOR (3 downto 0);
signal rca_cout	: STD_LOGIC;
signal gt_9		: STD_LOGIC;

signal m_s_digit_int : STD_LOGIC;


begin
	gt_9 <= '1' when (rca_s > 9) else '0';
	m_s_digit_int <= rca_cout or gt_9;
    m_s_digit <= m_s_digit_int;

	R1:  rca_dataflow PORT MAP (
			a => a,
			b => b,
			cin => cin,
			s => rca_s,
			cout => rca_cout
		 );

	R2:  rca_dataflow PORT MAP (
			a => rca_s,
			b => "0000", --"0110",
			cin => '0',
			s => rca_s6,
			cout => open
		 );

	U1:  mux_2_to_1_behavior PORT MAP (
			x => rca_s(3),
			y => rca_s6(3),
			s => m_s_digit_int,
			m => bcd_out(3)
		 );
		 
	U2:  mux_2_to_1_behavior PORT MAP (
			x => rca_s(2),
			y => rca_s6(2),
			s => m_s_digit_int,
			m => bcd_out(2)
		 );		 

	U3:  mux_2_to_1_behavior PORT MAP (
			x => rca_s(1),
			y => rca_s6(1),
			s => m_s_digit_int,
			m => bcd_out(1)
		 );
		 
	U4:  mux_2_to_1_behavior PORT MAP (
			x => rca_s(0),
			y => rca_s6(0),
			s => m_s_digit_int,
			m => bcd_out(0)
		 );		 

	B1: bcdto7segment_dataflow PORT MAP (
			x => bcd_out,
			an => an,
			seg => seg0
		);
		
end behavior;