--------------------------------------------
-- Module Name: cla_dataflow
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VComponents.all;

Entity cla_dataflow Is
port(
		p  	 : in STD_LOGIC_VECTOR(3 downto 0);
		g  	 : in STD_LOGIC_VECTOR(3 downto 0);
		cin  : in STD_LOGIC;
		cout : out STD_LOGIC_VECTOR(3 downto 0)
	);
end cla_dataflow;

Architecture behavior of cla_dataflow Is

Signal cout_int : STD_LOGIC_VECTOR(3 downto 0);

begin
    cout <= cout_int;

	cout_int(0) <= g(0) or (p(0) and cin);
	cout_int(1) <= g(1) or (p(1) and cout_int(0));
	cout_int(2) <= g(2) or (p(2) and cout_int(1));
	cout_int(3) <= g(3) or (p(3) and cout_int(2));
	
end behavior;