--------------------------------------------
-- Module Name: claadder_dataflow
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VComponents.all;

Entity claadder_dataflow Is
port(
		a  	 : in STD_LOGIC_VECTOR(3 downto 0);
		b  	 : in STD_LOGIC_VECTOR(3 downto 0);
		cin  : in STD_LOGIC;
		s  	 : out STD_LOGIC_VECTOR(3 downto 0);
		cout : out STD_LOGIC
	);
end claadder_dataflow;

Architecture behavior of claadder_dataflow Is
	Component fulladder_with_pg_dataflow
	port (
		a  	 : in STD_LOGIC;
		b  	 : in STD_LOGIC;
		cin  : in STD_LOGIC;
		p 	 : out STD_LOGIC;
		g 	 : out STD_LOGIC;		
		s : out STD_LOGIC
	);	
	End Component;

	Component cla_dataflow
	port (
		p  	 : in STD_LOGIC_VECTOR(3 downto 0);
		g  	 : in STD_LOGIC_VECTOR(3 downto 0);
		cin  : in STD_LOGIC;
		cout : out STD_LOGIC_VECTOR(3 downto 0)
	);	
	End Component;	
	
	Signal p : STD_LOGIC_VECTOR(3 downto 0);
	Signal g : STD_LOGIC_VECTOR(3 downto 0);
	Signal cout_i : STD_LOGIC_VECTOR(3 downto 0);

begin
	cout <= cout_i(3);
	
	F0:  fulladder_with_pg_dataflow PORT MAP (
			a => a(0),
			b => b(0),
			cin => cin,
			p => p(0),
			g => g(0),		
			s => s(0)
		 );

	F1:  fulladder_with_pg_dataflow PORT MAP (
			a => a(1),
			b => b(1),
			cin => cout_i(0),
			p => p(1),
			g => g(1),		
			s => s(1)
		 );

	F2:  fulladder_with_pg_dataflow PORT MAP (
			a => a(2),
			b => b(2),
			cin => cout_i(1),
			p => p(2),
			g => g(2),		
			s => s(2)
		 );

	F3:  fulladder_with_pg_dataflow PORT MAP (
			a => a(3),
			b => b(3),
			cin => cout_i(2),
			p => p(3),
			g => g(3),		
			s => s(3)
		 );

	C1:  cla_dataflow PORT MAP (
			p => p,
			g => g,
			cin => cin,
			cout => cout_i
		 );		
		 
end behavior;